/****************************** Module Header ******************************\
*
* Module Name: PMPIC.H
*
* OS/2 Presentation Manager Picture functions include file.
*
* Copyright (c) International Business Machines Corporation 1981, 1988-1992
*
* ===========================================================================
*
* Comments at the end of each typedef line give the name tags used in
* the assembler include version of this file.
*
* The assembler include version of this file excludes lines between XLATOFF
* and XLATON comments.
*
\***************************************************************************/

/* XLATOFF */
#if __IBMC__ || __IBMCPP__
   #pragma info( none )
   #ifndef __CHKHDR__
      #pragma info( none )
   #endif
   #pragma info( restore )
#endif
#ifdef __cplusplus
      extern "C" {
#endif
/* XLATON */

#define PIC_INCLUDED

typedef struct _METPARAMS  {  /* metp */
   PSZ read_filename;
   PSZ write_filename;
   LONG EbcdicCP;
   LONG D_EbcdicCP;
   LONG SymSetNameCP;
   LONG AsciiCP;
   LONG Options;
} METPARAMS;
typedef METPARAMS *PMETPARAMS;

/*** type of picture to print **********************************************/
#define PIP_MF       1L
#define PIP_PIF      2L

/*** type of conversion required *******************************************/
#define PIC_PIFTOMET 0L
#define PIC_SSTOFONT 2L
#define Pic32Print   PicPrint
#define Pic32Ichg    PicIchg
#define Prf32Pif2Met PrfPif2Met

BOOL APIENTRY PrfPif2Met(HAB hab,
                         USHORT whatisthis,
                         PMETPARAMS metParams);

#ifdef __cplusplus
BOOL APIENTRY PicPrint(HAB hab,
                       PCSZ  pszFilename,
                       LONG lType,
                       PCSZ  pszParams);

BOOL APIENTRY PicIchg(HAB hab,
                      PCSZ  pszFilename1,
                      PCSZ  pszFilename2,
                      LONG lType);
#else
BOOL APIENTRY PicPrint(HAB hab,
                       PSZ pszFilename,
                       LONG lType,
                       PSZ pszParams);

BOOL APIENTRY PicIchg(HAB hab,
                      PSZ pszFilename1,
                      PSZ pszFilename2,
                      LONG lType);

#endif

/* XLATOFF */
#ifdef __cplusplus
        }
#endif

#if __IBMC__ || __IBMCPP__
   #pragma info( none )
   #ifndef __CHKHDR__
      #pragma info( restore )
   #endif
   #pragma info( restore )
#endif
/* XLATON */

/**************************** end of file **********************************/
