
#ifndef WPColorPalette_Source
#define WPColorPalette_Source

#include <wppalet.hh>
#pragma off(dts_class);
#pragma on(somobject_assignment_operators);
#pragma on(somobject_constructors);
#pragma on(somobject_destructor);
#pragma off(case_insensitive_class_names);

#pragma on(som_bindings);
class WPColorPalette : public WPPalette {

     #pragma SOMMap (WPColorPalette, "WPColorPalette", "M_WPColorPalette")

     #pragma SOMClassVersion (WPColorPalette, 1, 2)

     #pragma SOMCallstyle (WPColorPalette, oidl)

     #pragma off(som_bindings);
     #pragma pop(som_bindings);
  public :

#pragma off(use_override_signature)
     virtual void wpPaintCell(PCELL pCell, HPS hps, PRECTL prcl,
                              BOOL fHilite);
     virtual BOOL wpEditCell(PCELL pCell, HWND hwndPal);
     virtual BOOL wpDragCell(PCELL pCell, HWND hwndPal, PPOINTL ptlDrag);
     virtual ULONG wpQueryPaletteHelp();
     virtual BOOL wpSetup(PSZ pszSetupString);
     virtual BOOL wpMenuItemHelpSelected(ULONG MenuId);
     virtual void wpInitData();
#pragma pop(use_override_signature)

     #pragma SOMReleaseOrder ()

};
#pragma pop(som_bindings);


#pragma pop(dts_class);
#pragma pop(somobject_assignment_operators);
#pragma pop(somobject_constructors);
#pragma pop(somobject_destructor);
#pragma pop(case_insensitive_class_names);
#endif /* WPColorPalette_Source */

#pragma off(som_bindings);
/* Paintpot structure */

typedef struct _PAINTPOT
{
   CELL        cell;     /* Size of the data that follows */
   ULONG       ulRGB;    /* Color of this paintpot */
} PAINTPOT;
typedef PAINTPOT *PPAINTPOT;

#pragma pop(som_bindings);

#ifndef M_WPColorPalette_Source
#define M_WPColorPalette_Source

#include <wppalet.hh>
#include <somcls.hh>
#pragma off(dts_class);
#pragma on(somobject_assignment_operators);
#pragma on(somobject_constructors);
#pragma on(somobject_destructor);
#pragma off(case_insensitive_class_names);

#pragma on(som_bindings);
class M_WPColorPalette : public M_WPPalette {

     #pragma SOMClassVersion (M_WPColorPalette, 1, 2)

     #pragma SOMCallstyle (M_WPColorPalette, oidl)

     #pragma off(som_bindings);
     #pragma pop(som_bindings);
  public :

#pragma off(use_override_signature)
     virtual PSZ wpclsQueryEditString();
     virtual PSZ wpclsQueryTitle();
     virtual ULONG wpclsQueryStyle();
     virtual BOOL wpclsQueryDefaultHelp(PULONG pHelpPanelId,
                                        PSZ pszHelpLibrary);
     virtual ULONG wpclsQueryIconData(PICONINFO pIconInfo);
#pragma pop(use_override_signature)

     #pragma SOMReleaseOrder ()

};
#pragma pop(som_bindings);

#pragma pop(dts_class);
#pragma pop(somobject_assignment_operators);
#pragma pop(somobject_constructors);
#pragma pop(somobject_destructor);
#pragma pop(case_insensitive_class_names);
#endif /* M_WPColorPalette_Source */

