
#ifndef WPFontPalette_Source
#define WPFontPalette_Source

#include <wppalet.hh>
#pragma off(dts_class);
#pragma on(somobject_assignment_operators);
#pragma on(somobject_constructors);
#pragma on(somobject_destructor);
#pragma off(case_insensitive_class_names);

#pragma on(som_bindings);
class WPFontPalette : public WPPalette {

     #pragma SOMMap (WPFontPalette, "WPFontPalette", "M_WPFontPalette")

     #pragma SOMClassVersion (WPFontPalette, 1, 2)

     #pragma SOMCallstyle (WPFontPalette, oidl)

     #pragma off(som_bindings);
     #pragma pop(som_bindings);
  public :

#pragma off(use_override_signature)
     virtual void wpPaintCell(PCELL pCell, HPS hps, PRECTL prcl,
                              BOOL fHilite);
     virtual BOOL wpEditCell(PCELL pCell, HWND hwndPal);
     virtual BOOL wpSetupCell(PVOID pCellData, ULONG cb, ULONG x,
                              ULONG y);
     virtual BOOL wpDragCell(PCELL pCell, HWND hwndPal, PPOINTL ptlDrag);
     virtual ULONG wpQueryPaletteHelp();
     virtual BOOL wpSetup(PSZ pszSetupString);
     virtual BOOL wpMenuItemHelpSelected(ULONG MenuId);
#pragma pop(use_override_signature)

     #pragma SOMReleaseOrder ( \
                              *)
};

#pragma pop(som_bindings);

#pragma pop(dts_class);
#pragma pop(somobject_assignment_operators);
#pragma pop(somobject_constructors);
#pragma pop(somobject_destructor);
#pragma pop(case_insensitive_class_names);
#endif /* WPFontPalette_Source */

#pragma off(som_bindings);
#define CCHFONTNAME   80

/* Fontpot structure */

typedef struct _FONTPOT
{
   CELL        cell;     /* Size of the data that follows */
   FATTRS      fAttrs;   /* fattrs from WinFontDlg/wpfattrsfrompsz */
   CHAR        szFont[CCHFONTNAME+1];
} FONTPOT;
typedef FONTPOT *PFONTPOT;

#pragma pop(som_bindings);

#ifndef M_WPFontPalette_Source
#define M_WPFontPalette_Source

#include <wppalet.hh>
#include <somcls.hh>
#pragma off(dts_class);
#pragma on(somobject_assignment_operators);
#pragma on(somobject_constructors);
#pragma on(somobject_destructor);
#pragma off(case_insensitive_class_names);

#pragma on(som_bindings);
class M_WPFontPalette : public M_WPPalette {

     #pragma SOMClassVersion (M_WPFontPalette, 1, 2)

     #pragma SOMCallstyle (M_WPFontPalette, oidl)

     #pragma off(som_bindings);
     #pragma pop(som_bindings);
  public :

#pragma off(use_override_signature)
     virtual PSZ wpclsQueryEditString();
     virtual PSZ wpclsQueryTitle();
     virtual ULONG wpclsQueryIconData(PICONINFO pIconInfo);
     virtual ULONG wpclsQueryStyle();
     virtual BOOL wpclsQueryDefaultHelp(PULONG pHelpPanelId,
                                        PSZ pszHelpLibrary);
#pragma pop(use_override_signature)

     #pragma SOMReleaseOrder ()

};
#pragma pop(som_bindings);

#pragma pop(dts_class);
#pragma pop(somobject_assignment_operators);
#pragma pop(somobject_constructors);
#pragma pop(somobject_destructor);
#pragma pop(case_insensitive_class_names);
#endif /* M_WPFontPalette_Source */

