
#ifndef WPKeyboard_Source
#define WPKeyboard_Source

#include <wpabs.hh>
#pragma off(dts_class);
#pragma on(somobject_assignment_operators);
#pragma on(somobject_constructors);
#pragma on(somobject_destructor);
#pragma off(case_insensitive_class_names);

#pragma on(som_bindings);
class WPKeyboard : public WPAbstract {

     #pragma SOMMap (WPKeyboard, "WPKeyboard", "M_WPKeyboard")

     #pragma SOMClassVersion (WPKeyboard, 1, 2)

     #pragma SOMCallstyle (WPKeyboard, oidl)

     #pragma off(som_bindings);
     #pragma pop(som_bindings);
  public :

#pragma off(use_override_signature)
     virtual ULONG wpAddKeyboardMappingsPage(HWND hwndNotebook);
     virtual ULONG wpAddKeyboardTimingPage(HWND hwndNotebook);
     virtual ULONG wpAddKeyboardSpecialNeedsPage(HWND hwndNotebook);
     virtual BOOL wpAddSettingsPages(HWND hwndNotebook);
     virtual ULONG wpAddObjectWindowPage(HWND hwndNotebook);
     virtual ULONG wpFilterPopupMenu(ULONG ulFlags, HWND hwndCnr,
                                     BOOL fMultiSelect);
#pragma pop(use_override_signature)

     #pragma SOMReleaseOrder ( \
                              wpAddKeyboardMappingsPage, \
                              wpAddKeyboardTimingPage, \
                              wpAddKeyboardSpecialNeedsPage)
};
#pragma pop(som_bindings);

#pragma pop(dts_class);
#pragma pop(somobject_assignment_operators);
#pragma pop(somobject_constructors);
#pragma pop(somobject_destructor);
#pragma pop(case_insensitive_class_names);
#endif /* WPKeyboard_Source */

#ifndef M_WPKeyboard_Source
#define M_WPKeyboard_Source

#include <wpabs.hh>
#include <somcls.hh>
#pragma off(dts_class);
#pragma on(somobject_assignment_operators);
#pragma on(somobject_constructors);
#pragma on(somobject_destructor);
#pragma off(case_insensitive_class_names);

#pragma on(som_bindings);
class M_WPKeyboard : public M_WPAbstract {

     #pragma SOMClassVersion (M_WPKeyboard, 1, 2)

     #pragma SOMCallstyle (M_WPKeyboard, oidl)

     #pragma off(som_bindings);
     #pragma pop(som_bindings);
  public :

#pragma off(use_override_signature)
     virtual PSZ wpclsQueryTitle();
     virtual BOOL wpclsQueryDefaultHelp(PULONG pHelpPanelId,
                                        PSZ pszHelpLibrary);
     virtual ULONG wpclsQueryDefaultView();
     virtual ULONG wpclsQueryStyle();
     virtual ULONG wpclsQueryIconData(PICONINFO pIconInfo);
#pragma pop(use_override_signature)

     #pragma SOMReleaseOrder ()

};
#pragma pop(som_bindings);

#pragma pop(dts_class);
#pragma pop(somobject_assignment_operators);
#pragma pop(somobject_constructors);
#pragma pop(somobject_destructor);
#pragma pop(case_insensitive_class_names);
#endif /* M_WPKeyboard_Source */

