
#ifndef WPMouse_Source
#define WPMouse_Source

#include <wpabs.hh>
#pragma off(dts_class);
#pragma on(somobject_assignment_operators);
#pragma on(somobject_constructors);
#pragma on(somobject_destructor);
#pragma off(case_insensitive_class_names);

#pragma on(som_bindings);
class WPMouse : public WPAbstract {

     #pragma SOMMap (WPMouse, "WPMouse", "M_WPMouse")

     #pragma SOMClassVersion (WPMouse, 1, 2)

     #pragma SOMCallstyle (WPMouse, oidl)

     #pragma off(som_bindings);
     #pragma pop(som_bindings);
  public :

#pragma off(use_override_signature)
     virtual ULONG wpAddMouseMappingsPage(HWND hwndNotebook);
     virtual ULONG wpAddMouseTimingPage(HWND hwndNotebook);
     virtual ULONG wpAddMouseTypePage(HWND hwndNotebook);
     virtual BOOL wpAddSettingsPages(HWND hwndNotebook);
     virtual ULONG wpAddObjectWindowPage(HWND hwndNotebook);
     virtual ULONG wpFilterPopupMenu(ULONG ulFlags, HWND hwndCnr,
                                     BOOL fMultiSelect);
#pragma pop(use_override_signature)

     #pragma SOMReleaseOrder ( \
                              wpAddMouseMappingsPage, \
                              wpAddMouseTimingPage, \
                              wpAddMouseTypePage)
};
#pragma pop(som_bindings);

#pragma pop(dts_class);
#pragma pop(somobject_assignment_operators);
#pragma pop(somobject_constructors);
#pragma pop(somobject_destructor);
#pragma pop(case_insensitive_class_names);
#endif /* WPMouse_Source */

#ifndef M_WPMouse_Source
#define M_WPMouse_Source

#include <wpabs.hh>
#include <somcls.hh>
#pragma off(dts_class);
#pragma on(somobject_assignment_operators);
#pragma on(somobject_constructors);
#pragma on(somobject_destructor);
#pragma off(case_insensitive_class_names);

#pragma on(som_bindings);
class M_WPMouse : public M_WPAbstract {

     #pragma SOMClassVersion (M_WPMouse, 1, 2)

     #pragma SOMCallstyle (M_WPMouse, oidl)

     #pragma off(som_bindings);
     #pragma pop(som_bindings);
  public :

#pragma off(use_override_signature)
     virtual PSZ wpclsQueryTitle();
     virtual BOOL wpclsQueryDefaultHelp(PULONG pHelpPanelId,
                                        PSZ pszHelpLibrary);
     virtual ULONG wpclsQueryDefaultView();
     virtual ULONG wpclsQueryStyle();
     virtual ULONG wpclsQueryIconData(PICONINFO pIconInfo);
#pragma pop(use_override_signature)

     #pragma SOMReleaseOrder ()

};
#pragma pop(som_bindings);

#pragma pop(dts_class);
#pragma pop(somobject_assignment_operators);
#pragma pop(somobject_constructors);
#pragma pop(somobject_destructor);
#pragma pop(case_insensitive_class_names);
#endif /* M_WPMouse_Source */

