#
#  OpenGL auxdemo Makefile
#
#  Copyright (C) 1992 IBM Corporation
#
#      DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
#      sample code created by IBM Corporation. This sample code is not
#      part of any standard or IBM product and is provided to you solely
#      for  the purpose of assisting you in the development of your
#      applications.  The code is provided "AS IS", without
#      warranty of any kind.  IBM shall not be liable for any damages
#      arising out of your use of the sample code, even if they have been
#      advised of the possibility of such damages.                                                    *
#
#===================================================================
# Include the file ibmsamp.inc which defines the various macros
# depending on the target specified.
#===================================================================

!include ..\..\ibmsamp.inc

!if "$(TARGET_PROC)"=="PPC" || "$(TARGET_PROC)"=="ppc"
RESFLAGS = -q
!if "$(COMPILER)"!="VAPPC"
CFLAGS=$(CFLAGS) -DMETAWARE -Hon=PCC
!endif
!else
!if "$(TARGET_PROC)"=="386"
!endif
!endif

EXECS = accanti.exe \
        accnot.exe \
        accpersp.exe \
        accum.exe \
        aim.exe \
        alpha.exe \
        alpha3D.exe \
        anti.exe \
        antindx.exe \
        antipndx.exe \
        antipnt.exe \
        antipoly.exe \
        bezcurve.exe \
        bezmesh.exe \
        bezsurf.exe \
        checker.exe \
        checker2.exe \
        chess.exe \
        clip.exe \
        colormat.exe \
        cone.exe \
        cube.exe \
        curve.exe \
        depthcue.exe \
        disk.exe \
        dof.exe \
        dofnot.exe \
        double.exe \
        drawf.exe \
        feedback.exe \
        fog.exe \
        fogindex.exe \
        font.exe \
        light.exe \
        linelist.exe \
        lines.exe \
        list.exe \
        list2.exe \
        maplight.exe \
        material.exe \
        mipmap.exe \
        model.exe \
        movelite.exe \
        nurbs.exe \
        pickdep.exe \
        pickline.exe \
        picksqr.exe \
        plane.exe \
        planet.exe \
        planetup.exe \
        polys.exe \
        robot.exe \
        scene.exe \
        sceneamb.exe \
        scenef.exe \
        scenelit.exe \
        select.exe \
        simple.exe \
        smooth.exe \
        sphere.exe \
        stencil.exe \
        stroke.exe \
        surface.exe \
        tea.exe \
        teaamb.exe \
        teapots.exe \
        texgen.exe \
        texsurf.exe \
        trim.exe

all:   $(EXECS)

# Resources
#
!if "$(TARGET_PROC)"=="386"
!else
!if "$(TARGET_PROC)"=="PPC"
!endif
!endif

# Main files:
#
!if "$(TARGET_PROC)"=="386"
$(EXECS): $(@B).obj sampogl.def
    $(LINK) @<<$(@B).lnk
$(OBJS: =+^
)
$@
$(@B).map
$(MTLIBS)
$(@B).def
<<keep
!else
!if "$(TARGET_PROC)"=="PPC" || "$(TARGET_PROC)"=="ppc"
$(EXECS): $(@B).obj sampogl.def
        @echo Working on: $(@B)
        $(LINK) $(LFLAGS) $@ $(DEFOPTS)sampogl.def $(AUXLIBS) $(@B).obj
!endif
!endif

clean :
        if exist *.obj del *.obj
        if exist *.dll del *.dll
        if exist *.exe del *.exe

