#===================================================================
# NMAKE-compatible MAKE file for the REXX sample program REXXUTIL.
# Include the file ibmsamp.inc which defines the various macros
# depending on the target specified.
#===================================================================

include ..\..\..\ibmsamp.inc

#-------------------------------------------------------------------
#   A list of all of the object files
#-------------------------------------------------------------------

OBJS = rexxutil.obj

#-------------------------------------------------------------------
#   This section lists all files to be built by the make.  The
#   makefile builds the executible as well as its associated help
#   file.
#-------------------------------------------------------------------
all: rexxutil.dll

#===================================================================
#
# Dependencies
#
#   This section lists all object files needed to be built for the
#   application, along with the files it is dependent upon (e.g. its
#   source and any header files).
#
#===================================================================

rexxutil.obj: rexxutil.c
        $(CC) $(DLLCFLAGS) $(DBG_CFLAGS) $*.c

#-------------------------------------------------------------------
#   This section links the object modules into the finished program
#   using the linker command file created earlier.  At the end, the
#   resource file is bound to the application.
#-------------------------------------------------------------------

!if "$(TARGET_PROC)"=="386"
rexxutil.dll: $(OBJS) rexxutil.def
    $(LINK) @<<rexxutil.lnk
$(OBJS: =+
)
$@
$(@B).map
$(MTLIBS)
-Irexx
$(@B).def
<<keep
!endif

!if "$(TARGET_PROC)"=="PPC" || "$(TARGET_PROC)"=="ppc"
rexxutil.dll : $(OBJS) rexxutil.def
        $(LINK) $(REXXFLAGS) $(DLLFLAGS) $(LFLAGS) $@ $(DEFOPTS)rexxutil.def $(OBJS)
!endif

clean :
        if exist *.obj del *.obj
        if exist *.dll del *.dll
